<?php
/*
Plugin Name: AdSense Manager
PLugin URI: http://wordpress.org/extend/plugins/adsense-manager/
Description: Control and arrange your AdSense & Referral blocks on your Wordpress blog. With Widget and inline post support, configurable colours. 
Author: Martin Fitzpatrick
Version: 3.0
Author URI: http://www.mutube.com/
*/

/*
TODO:

Defaults
* highlight the fields for which there are default settings
* is this making code overcomplicated? rearrange into functions/etc.

*/

@define("ADSENSEM_VERSION", "3.0");
@define('ADSENSEM_DIRPATH','/wp-content/plugins' . strrchr(dirname(__FILE__),'/') . "/");

/*
	CONSTANTS FOR CONFIGURATION
*/

//Currently not used
//@define("ADSENSEM_MAX_ADS", 7); //Max Google Ad units
//@define("ADSENSEM_MAX_REFERRALS", 7); //Max Google Referral units
		
@define("ADSENSEM_BE_NICE", 3); //Default level only, can be changed in Options/AdSense Manager

		
/*  Copyright 2006  MARTIN FITZPATRICK  (email : martin.fitzpatrick@gmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

//Now ad networks are managed by dedicated classes. How modern.
require_once('class-generic.php');
	
require_once('class-adsense.php'); //Adsense (using Slots, etc.)

	require_once('class-adsense-classic.php'); //AdSense units pre-slot style
	require_once('class-adsense-ad.php'); //AdSense Ad units pre-slot style
	require_once('class-adsense-link.php'); //AdSense Link units pre-slot style
	require_once('class-adsense-referral.php'); //AdSense Referral units pre-slot style

require_once('class-adpinion.php'); //Adpinion
require_once('class-adroll.php'); //AdRoll
require_once('class-adbrite.php'); //AdBrite
require_once('class-cj.php'); //Commission Junction
//require('class-ypn.php'); //Yahoo! Publisher Network - not yet supported
require_once('class-code.php'); //HTML Code
require_once('class-shoppingads.php'); //ShoppingAds
require_once('class-widgetbucks.php'); //Widgetbucks

if(is_admin()){ require_once('class-admin.php'); } //Admin interface functions (keep out while browsing main site

$_adsensem = get_option('plugin_adsensem');
$_adsensem_notices = array();


/*

   STANDARD OUTPUT FUNCTIONS
   These are out of the main function block below so they can be called
   from outside "widget-space".  This means we can re-use code for widget
   and non-widget versions

*/

//Kept external for backward compatibility
if(!function_exists('adsensem_ad')) {
	function adsensem_ad($name=false) {
		global $_adsensem;
		if($name===false)
			{$ad=$_adsensem['ads'][$_adsensem['default-ad']];}	
		else
			{$ad=$_adsensem['ads'][$name];}
		echo adsensem::get_ad($ad,$name);
	}
}


/*

  INITIALISATION
  All functions in here called at startup (after other plugins have loaded, in case
  we need to wait for the widget-plugin).
*/

class adsensem {
	
	//STARTUP INITIALISATION
		function init(){
		
			global $_adsensem;
			
			//Only run main site code if setup & functional
			if(adsensem::setup_is_valid()){
				add_filter('the_content', array('adsensem','filter_ads')); 
				add_action('wp_footer', array('adsensem','footer'));
			}

			add_action('admin_menu', array('adsensem_admin','init_admin'));
			add_action('admin_head', array('adsensem_admin','add_header_script'));
			add_action('admin_footer', array('adsensem_admin','admin_callback_editor'));

		}
	
		function setup_is_valid(){
			global $_adsensem;
			if(is_array($_adsensem)){
				if(is_array($_adsensem['ads'])){
					if(is_object($_adsensem['ads'][$_adsensem['default-ad']])){
						return true;
					}
				}
			}
			return false;
		}
		
		function init_widgets()
		{
			global $_adsensem;
			/* SITE SECTION: WIDGET DISPLAY CODE
			/* Add the blocks to the Widget panel for positioning WP2.2+*/
			$args = array('n' => $name, 'height' => 80, 'width' => 300);
			
			if (function_exists('wp_register_sidebar_widget') )
			{
				/* Loop through available ads and generate widget one at a time */
				if(is_array($_adsensem['ads'])){
					foreach($_adsensem['ads'] as $name => $ad){
						$args = array('n' => $name, 'height' => 80, 'width' => 300);
						//$id, $name, $output_callback, $_adsensem = array()
						wp_register_sidebar_widget('adsensem-' . $name,'Ad #' . $name, array('adsensem','widget'), $args, $name);
						wp_register_widget_control('adsensem-' . $name,'Ad #' . $name,  array('adsensem','widget_control'), $args, $name); 
					}
				}

      } 			
			
		}
	

 	    // This is the function that outputs adsensem widget.
	  function widget($args, $n=0) {
		// $args is an array of strings that help widgets to conform to
		// the active theme: before_widget, before_title, after_widget,
		// and after_title are the array keys. Default tags: li and h2.
		extract($args);
		global $_adsensem;

		// Each widget can store its own options. We keep strings here.
		$ad = $_adsensem['ads'][$n];
		
		// These lines generate our output. Widgets can be very complex
		// but as you can see here, they can also be very, very simple.
		echo $before_widget;
			if($ad->title!=''){ echo $before_title . $ad->title . $after_title; }
			echo $ad->get_ad(); //Output the selected ad
		echo $after_widget;
	    }

		/* Widget admin block for each Ad element on the page, allows
			movement of them around the sidebar */
	  function widget_control($name)
		{
			global $_adsensem;
							
			if ( $_POST['adsensem-' . $name . '-submit'] ) {
				global $_adsensem;
				// Remember to sanitize and format use input appropriately.
				$_adsensem['ads'][$name]->title = strip_tags(stripslashes($_POST['adsensem-' . $name . '-title']));
				update_option('plugin_adsensem', $_adsensem);
			}

			?>
			<label for="adsensem-<?php echo $name; ?>-title" >Title:</label><input style="width: 200px;" id="adsensem-<?php echo $name; ?>-title" name="adsensem-<?php echo $name; ?>-title" type="text" value="<?php echo htmlspecialchars($_adsensem['ads'][$name]->title, ENT_QUOTES);?>" />
			<input type="hidden" name="adsensem-<?php echo $name; ?>-submit" value="1">
			<?php

        }
			
	

				
				
				
				
		function footer(){
		?><!-- AdSense Manager v<?php echo ADSENSEM_VERSION;?> (<?php timer_stop(1); ?> seconds.) --><?php
		}



		/* This filter parses post content and replaces markup with the correct ad,
			<!--adsense#name--> for named ad or <!--adsense--> for default */
		function filter_ads($content) {
		global $_adsensem;

			if(is_object($_adsensem['ads'][$_adsensem['default-ad']])){
				//Insert default ad first
				$content=str_replace(array("<!--adsense-->","<!--am-->"),$_adsensem['ads'][$_adsensem['default-ad']]->get_ad(),$content);
				
				foreach($_adsensem['ads'] as $name=>$ad)
					{	$content = str_replace(array("<!--adsense#" . $name .  "-->","<!--am#" . $name .  "-->"), $ad->get_ad(), $content); }
			}

    		return $content;
		}

}



/* SHOW ALTERNATE AD UNITS */
if ($_REQUEST['adsensem-show-ad']){
	?><html><body><?php
	adsensem_ad($_REQUEST['adsensem-show-ad']);
	?></body></html><?php
	die(0);
}
/* END SHOW ALTERNATE AD UNITS */

/* SHOW BENICE UNITS */
if ($_REQUEST['adsensem-benice']){
	?><html><body><?php
	echo adsensem_benice::benice_code($_REQUEST['adsensem-benice']); //contains format
	?></body></html><?php
	die(0);
}
/* END BENICE UNITS */





/* PRE-OUTPUT PROCESSING - e.g. NOTICEs (upgrade-adsense-deluxe) */
switch ($_POST['adsensem-mode'].':'.$_POST['adsensem-action']){
	case 'notice:upgrade adsense-deluxe':
		if($_POST['adsensem-notice-confirm-yes']){
			require('class-upgrade.php');
			adsensem_upgrade::adsense_deluxe_to_3_0();
			adsensem_admin::remove_notice('upgrade adsense-deluxe');
		} else {
			adsensem_admin::remove_notice('upgrade adsense-deluxe');
		}
	break;	
	case 'notice:upgrade adsense-manager':
		adsensem_admin::remove_notice('upgrade adsense-manager');
	break;
}
/* END PRE-OUTPUT PROCESSING */



add_action('plugins_loaded', array('adsensem','init'), 1);	
add_action('widgets_init',  array('adsensem','init_widgets'), 1);	

?>
